from .Layer import Layer

import Models.Layouts as Layouts
from Controllers.TensorFormat import LayerIOFormat, LayerIOFormatPair

class Conversion(Layer):
    _supported_IO_formats = [
        LayerIOFormat.getLayerIOFormatPair(LayerIOFormatPair.NCHW_to_NCHW_fullstride),
        LayerIOFormat.getLayerIOFormatPair(LayerIOFormatPair.NCHW_to_NHWC_fullstride),
        LayerIOFormat.getLayerIOFormatPair(LayerIOFormatPair.NCHW_to_NHCW_fullstride),

        LayerIOFormat.getLayerIOFormatPair(LayerIOFormatPair.NHWC_to_NCHW_fullstride),
        LayerIOFormat.getLayerIOFormatPair(LayerIOFormatPair.NHWC_to_NHWC_fullstride),
        LayerIOFormat.getLayerIOFormatPair(LayerIOFormatPair.NHWC_to_NHCW_fullstride),

        LayerIOFormat.getLayerIOFormatPair(LayerIOFormatPair.NHCW_to_NCHW_fullstride),
        LayerIOFormat.getLayerIOFormatPair(LayerIOFormatPair.NHCW_to_NHWC_fullstride),
        LayerIOFormat.getLayerIOFormatPair(LayerIOFormatPair.NHCW_to_NHCW_fullstride),
        ]

    def __init__(self, *args):
        super().__init__(*args)
