# Copyright 2018 Intel Corporation.
# The source code, information and material ("Material") contained herein is
# owned by Intel Corporation or its suppliers or licensors, and title to such
# Material remains with Intel Corporation or its suppliers or licensors.
# The Material contains proprietary information of Intel or its suppliers and
# licensors. The Material is protected by worldwide copyright laws and treaty
# provisions.
# No part of the Material may be used, copied, reproduced, modified, published,
# uploaded, posted, transmitted, distributed or disclosed in any way without
# Intel's prior express written permission. No license under any patent,
# copyright or other intellectual property rights in the Material is granted to
# or conferred upon you, either expressly, by implication, inducement, estoppel
# or otherwise.
# Any license under such intellectual property rights must be express and
# approved by Intel in writing.

from Controllers.Parsers.Parser.ReshapeHWC import ReshapeHWC
from . import Helpers as tf_helpers
from Controllers.EnumController import throw_error, ErrorTable, compiler_assert

def load(obj, operations, feed_dict):
    # two inputs/one output
    compiler_assert(len(obj.inputs) == 2, ErrorTable.StageDetailsNotSupported, obj.name)
    compiler_assert(len(obj.outputs) == 1, ErrorTable.StageDetailsNotSupported, obj.name)

    x = ReshapeHWC(obj.name, [obj.inputs[0].name], tf_helpers.getOutputNames(obj))

    return[x]
