# Copyright 2018 Intel Corporation.
# The source code, information and material ("Material") contained herein is
# owned by Intel Corporation or its suppliers or licensors, and title to such
# Material remains with Intel Corporation or its suppliers or licensors.
# The Material contains proprietary information of Intel or its suppliers and
# licensors. The Material is protected by worldwide copyright laws and treaty
# provisions.
# No part of the Material may be used, copied, reproduced, modified, published,
# uploaded, posted, transmitted, distributed or disclosed in any way without
# Intel's prior express written permission. No license under any patent,
# copyright or other intellectual property rights in the Material is granted to
# or conferred upon you, either expressly, by implication, inducement, estoppel
# or otherwise.
# Any license under such intellectual property rights must be express and
# approved by Intel in writing.

from Controllers.Parsers.Parser.SumReduce import SumReduce
from Controllers.Parsers.TensorFlowParser.Helpers import getInputNames, getOutputNames, findTensorValue
import numpy as np

from Controllers.EnumController import throw_error, ErrorTable, compiler_assert

def load(obj, operations, feed_dict):
    try:
        axis = obj.get_attr('axis')
    except:
        axis = None
    input_shape = obj.inputs[0].get_shape()

    print("axis: ", axis)
    print("input_shape: ", input_shape)
    if (axis is not None and (len(axis) != 1 or axis[0] != 3)) or \
        not(axis is None and any(input_shape[0:-1]) == 1):
        throw_error(ErrorTable.StageDetailsNotSupported,
            "SumReduce layer {0}: Unsupported axis parameter value." +
            "Parmeter axis must be in = {{-1, 3, None}} got {1}." +
            " If axis=None then input shape must be (B,1,1,C)".format(
                obj.name, axis))

    x = SumReduce(obj.name, [getInputNames(obj)[0]], getOutputNames(obj))
    x.setAxis(axis=3)

    return [x]