# Copyright 2018 Intel Corporation.
# The source code, information and material ("Material") contained herein is
# owned by Intel Corporation or its suppliers or licensors, and title to such
# Material remains with Intel Corporation or its suppliers or licensors.
# The Material contains proprietary information of Intel or its suppliers and
# licensors. The Material is protected by worldwide copyright laws and treaty
# provisions.
# No part of the Material may be used, copied, reproduced, modified, published,
# uploaded, posted, transmitted, distributed or disclosed in any way without
# Intel's prior express written permission. No license under any patent,
# copyright or other intellectual property rights in the Material is granted to
# or conferred upon you, either expressly, by implication, inducement, estoppel
# or otherwise.
# Any license under such intellectual property rights must be express and
# approved by Intel in writing.


from .Layer import Layer
from Controllers.TensorFormat import LayerIOFormat, LayerIOFormatPair
import Models.Layouts as Layouts

class Concat(Layer):
    _supported_IO_formats = [
        LayerIOFormat.getLayerIOFormatPair(LayerIOFormatPair.NHCW_to_NHCW_fullstride),
        LayerIOFormat.getLayerIOFormatPair(LayerIOFormatPair.NHWC_to_NHWC_fullstride),
        LayerIOFormat.getLayerIOFormatPair(LayerIOFormatPair.NCHW_to_NCHW_fullstride),
        ]

    def __init__(self, *args):
        super().__init__(*args)

    def loadConcatAxis(self, axis):
        self.axis = axis

    def getAxis(self):
        try:
            return self.axis
        except:
            return 1

    def getIOFormats(self):
        self._supported_IO_formats = [
            tuple([io_format[0],]*len(self.getInputTensorNames())) + (io_format[1],)
            for io_format in self._supported_IO_formats]

        concat_formats = super().getIOFormats()
        return concat_formats
